
#define ID_FILE_SAVE                    40001
#define ID_FILE_EXIT                    40002
#define ID_PROGRAM_RUN                  40011
#define ID_PROGRAM_RESET                40012
#define ID_HELP_ABOUT                   40021

class plotter
{
public:
    plotter( char *, char * );
    void initialize( HINSTANCE );
    void create( int );
    bool window_class();
    int  message_loop();

    void on_command( HWND, WPARAM );
    void on_create( HWND );
    void on_destroy();
    void on_hscroll( HWND, WPARAM );
    void on_paint( HWND );
    void on_size( HWND );
    void on_vscroll( HWND, WPARAM );
    
    void  draw_axes();
    void  plot_region( double, double, double, double );
    void  red_curve( POINT *, int );
    void  green_curve( POINT *, int );
    void  blue_curve( POINT *, int );
    POINT plot_point( double, double );

private:
    void  about( HWND );
    int   file_save_dlg( HWND, PSTR, PSTR );
    BOOL  save_bitmap( HDC, HBITMAP, PSTR );
    HMENU menu();
    
    HINSTANCE hInstance;                        // instance of this program
    char class_name[64];
    char plotter_name[64];
    RECT current;                               // current client dimensions
    HDC hMemoryDC;                              // handle of memory DC
    HBITMAP hbit;                               // handle of compatible bitmap
    HPEN hOldpen;                               // handle of saved drawing pen
    HPEN hRedpen, hGreenpen, hBluepen;          // drawing pens
    
    int X_max_pixels, Y_max_pixels;             // full screen dimensions
    int X_org, Y_org;                           // origin for painting bitmap
    
    int X0_pixel, Y0_pixel;                     // coordinate origin in pixels
    double dX, dY;                              // pixels per unit
    bool plot_region_defined;                   // when true, plot region setup
};

LRESULT CALLBACK WindowFunc( HWND, UINT, WPARAM, LPARAM );
